unit BeeperWrapper;

interface

uses
  WinRing0;

const
//         :
  C0  = 130.82; C1  = 261.63; C2  = 523.25; C3  = 1046.50; C4  = 2093.00;
  C0S = 138.59; C1S = 277.18; C2S = 554.36; C3S = 1108.70; C4S = 2217.40;
  D0  = 147.83; D1  = 293.33; D2  = 587.32; D3  = 1174.60; D4  = 2349.20;
  D0S = 155.56; D1S = 311.13; D2S = 622.26; D3S = 1244.50; D4S = 2489.00;
  E0  = 164.81; E1  = 329.63; E2  = 659.26; E3  = 1318.50; E4  = 2637.00;
  F0  = 174.62; F1  = 349.23; F2  = 698.46; F3  = 1396.90; F4  = 2793.80;
  F0S = 185.00; F1S = 369.99; F2S = 739.98; F3S = 1480.00; F4S = 2960.00;
  G0  = 196.00; G1  = 392.00; G2  = 784.00; G3  = 1568.00; G4  = 3136.00;
  G0S = 207.00; G1S = 415.30; G2S = 830.60; G3S = 1661.20; G4S = 3322.40;
  A0  = 220.00; A1  = 440.00; A2  = 880.00; A3  = 1760.00; A4  = 3520.00;
  A0S = 233.08; A1S = 466.16; A2S = 932.32; A3S = 1864.60; A4S = 3729.20;
  B0  = 246.96; B1  = 494.88; B2  = 987.75; B3  = 1975.50; B4  = 3951.00;

const
//  :
  Gamma: array [0..34] of Single = (
    C0, D0, E0, F0, G0, A0, B0,
    C1, D1, E1, F1, G1, A1, B1,
    C2, D2, E2, F2, G2, A2, B2,
    C3, D3, E3, F3, G3, A3, B3,
    C4, D4, E4, F4, G4, A4, B4
  );

//  :
  ChromaticGamma: array [0..59] of Single = (
    C0, C0S, D0, D0S, E0, F0, F0S, G0, G0S, A0, A0S, B0,
    C1, C1S, D1, D1S, E1, F1, F1S, G1, G1S, A1, A1S, B1,
    C2, C2S, D2, D2S, E2, F2, F2S, G2, G2S, A2, A2S, B2,
    C3, C3S, D3, D3S, E3, F3, F3S, G3, G3S, A3, A3S, B3,
    C4, C4S, D4, D4S, E4, F4, F4S, G4, G4S, A4, A4S, B4
  );

function InitializeBeeper: LongWord;
function DeinitializeBeeper: Boolean;

procedure StartBeeper;
procedure StopBeeper;
procedure SetBeeperRegime;

procedure SetBeeperDivider(Value: Word);
procedure SetBeeperFrequency(Value: Single);

implementation

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function InitializeBeeper: LongWord;
begin
  InitializeOls;
  Result := GetDLLStatus;
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function DeinitializeBeeper: Boolean;
begin
  Result := DeinitializeOls;
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

procedure StartBeeper;
var
  Value: Byte;
begin
{
  ;  2 ,       61h:
  in al, 61h
  or al, 00000011b
  out 61h, al
}
  Value := ReadIoPortByte($61);
  Value := Value or 3;
  WriteIoPortByte($61, Value);
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

procedure StopBeeper;
var
  Value: Byte;
begin
{
  ;       61h,    :
  in al, 61h
  and al, 11111100b
  out 61h, al
}
  Value := ReadIoPortByte($61);
  Value := Value and 252;
  WriteIoPortByte($61, Value);
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

procedure SetBeeperRegime;
const
  InitializationValue: Byte = $0B6;
begin
{
  ;  :
  mov al, $0B6h ; 0B6h = 10 11 011 0
          10 =  ,     (10b =  )
          11 =   (11b = /  ,    )
         011 =    (011b =    ( ))
           0 =   (0 = 16-   0  0FFFFh)
  out 43h, al
}
  WriteIoPortByte($43, InitializationValue);
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

procedure SetBeeperDivider(Value: Word);
begin
  WriteIoPortByte($42, Byte(Value)); //  
  WriteIoPortByte($42, Byte(Pointer(NativeUInt(@Value) + 1)^)); //  
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

procedure SetBeeperFrequency(Value: Single);
begin
  SetBeeperDivider(Word(Round(1193180 / Value)));
end;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

end.
